/*
 * Copyright 2014 Pierre-Edouard Portier, Mazen Alsarem
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#ifndef LDPR_H
#define LDPR_H

#define min(a,b) ((a) < (b) ? (a) : (b))
#define max(a,b) ((a) < (b) ? (b) : (a))

/* indexed double struct */
typedef struct 
{
  size_t index; /* original position in the embedding structure */
  double value;
} IDouble;

void 
mk_teleport();

void 
mk_stochastic();

void 
mk_primitive();

void 
power_it();

double 
eucl_norm(size_t n, double const * const v);

int 
compare_idouble_value(void const * a, void const * b);

void 
idouble_sort(IDouble* values, long size);

#endif /* LDPR_H */
